<h1>Users</h1>

<button id="add-user" routerLink="/users/add" mat-fab color="primary" aria-label="New user">
  <mat-icon>add</mat-icon>
</button>

<table mat-table *ngIf="users$ | async as users; else spinner" [dataSource]="users" class="mat-elevation-z8">

  <ng-container matColumnDef="id">
    <th mat-header-cell *matHeaderCellDef> Id </th>
    <td mat-cell *matCellDef="let user"> {{user.id}} </td>
  </ng-container>

  <ng-container matColumnDef="name">
    <th mat-header-cell *matHeaderCellDef> Name </th>
    <td mat-cell *matCellDef="let user"> {{user.name}} </td>
  </ng-container>

  <ng-container matColumnDef="email">
    <th mat-header-cell *matHeaderCellDef> Email </th>
    <td mat-cell *matCellDef="let user"> {{user.email}} </td>
  </ng-container>

  <ng-container matColumnDef="actions">
    <th mat-header-cell *matHeaderCellDef> Actions </th>
    <td mat-cell *matCellDef="let user">
      <button mat-icon-button [routerLink]="'/users/' + user.id + '/edit'" aria-label="Edit user">
        <mat-icon>edit</mat-icon>
      </button>
      <button mat-icon-button (click)="onDelete(user)" aria-label="Remove user">
        <mat-icon>delete</mat-icon>
      </button>
    </td>
  </ng-container>

  <tr mat-header-row *matHeaderRowDef="['id', 'name', 'email', 'actions']"></tr>
  <tr mat-row *matRowDef="let row; columns: ['id', 'name', 'email', 'actions'];"></tr>
</table>


<ng-template #spinner>
  <mat-spinner></mat-spinner>
</ng-template>
